module Buckaroo.HelpCommand

let private log (x : string) = System.Console.WriteLine(x)

let task = async {
  log("$ buckaroo init")
  log("Create a Buckaroo manifest in the current working directory. ")
  log("")
  log("$ buckaroo resolve")
  log("Generates a fresh lock-file from the existing manifest. ")
  log("")
  log("$ buckaroo install")
  log("Installs the packages as described in the current lock-file. ")
  log("")
  log("$ buckaroo add <package>@<version>...")
  log("Adds the given package(s) to the current manifest, updates the lock-file and installs it to the packages folder. ")
  log("If no satisfactory resolution can be found then nothing is changed. ")
  log("")
  log("$ buckaroo upgrade [ <package> [ @<version> ] ]")
  log("Upgrades the given package(s) to the highest version that meets the constraints in the manifest. ")
  log("Optionally, a version can be specified to move the package to. ")
  log("If no packages are specified, then all are upgraded. ")
  log("")
  log("$ buckaroo remove <package>...")
  log("Removes an existing package from the manifest, updates the lock-file and deletes it from the packages folder. ")
  log("If no satisfactory resolution can be found then nothing is changed. ")
  log("")
  log("$ buckaroo version")
  log("Displays the version of this installation of Buckaroo. ")
  log("")
  log("$ buckaroo help")
  log("Displays this message. ")
  log("")
  log("For more information, visit: ")
  log("https://buckaroo.readthedocs.io/")
}
